;;; DESCription.lsp
;;;
;;; Boilerplate:
;;;
;;; This is a program to draw an elliptical and expandable balloon containing
;;; a part number after what the program asks several questions wich can be 
;;; skipped or answred and printed on screen one by one below the balloon and
;;; title, thus completing the DESCription.
;;;
;;; This thing is mine but I will not be held responsible for it's 
;;; misbehavior if there is.
;;;
;;;
;;; Yvan Paquet  
;;; Tel: 514-641-2913
;;; Compuserve ID: 76460,774


;;; Error traps
(defun dscerr (msg)
 (if (member msg '("console break" "Function cancelled" "cancel"))
    (princ "\n*User ")
   (princ (strcat "\nError: " msg))
  );if
 (dscreset)
 (princ)
 );defun

(defun dcfger (cfmsg)
 (if (member msg '("console break" "Function cancelled" "cancel"))
    (princ "\n*User ")
   (princ (strcat "\nError: " msg))
  );if
 (setq *error* acaderr)
 (princ)
 );defun


;;; Reset function
(defun dscreset ()
 (setvar "clayer" cla)
 (setvar "osmode" osm)
 (setvar "orthomode" ort)
 (setvar "snapmode" sna)
 (setvar "blipmode" blip)
 (setvar "cmdecho" eco)
 (setvar "textsize" dfht)
 (setq *error* acaderr)
 );defun


;;; Main function
(defun desc (/ eco osm cla rad rad1 p1 p2 p3 p4 txpt txptx txpty balstr 
                 defstr txtht baltxt var0 tmpht1 txtht1 bx bxr bxl hrl vrl 
                 lcenpt tcenpt tmppt2 pt2 destxt tmpht2 txtht2 test inc inc1 
                 pt1 pt4 pt3 ptmp baltxt dfht promp fixe free OK prt rawstr
                 str1 str2 destr shift fixed hard matl lakw snot fla lanam 
                 kwprp blip elst txsty bblrad col# lacfg lacol wstr)
 (setq eco (getvar "cmdecho")
       cla (getvar "clayer")
       fla (cdr (assoc 70 (tblsearch "layer" "DE$C")))
       lanam (cdr (assoc 2 (tblsearch "layer" "DE$C")))
       wstr (getvar "users5")
       ort (getvar "orthomode")
       sna (getvar "snapmode")
       osm (getvar "osmode")
       blip (getvar "blipmode")
       shift (getvar "users2")
       hard (getvar "users3")
       matl (getvar "users4")
       txsty (cons 7 (getvar "textstyle"))
       lacfg ""
       acaderr *error*
       *error* dscerr
  );setq
 (while (wcmatch wstr "* *")
         (setq lacfg (strcat lacfg (substr wstr 1 1))
               wstr (substr wstr 2)
               lacol (strcase wstr)
          );setq
         (if (wcmatch lacfg "* ")
              (setq lacfg (substr lacfg 1 (1- (strlen lacfg))))
          );if
  );while
 (cond
  ((= lacol "RED")
    (setq col# 1)
   );cond1
  ((= lacol "YELLOW")
    (setq col# 2)
   );cond1
  ((= lacol "GREEN")
    (setq col# 3)
   );cond1
  ((= lacol "CYAN")
    (setq col# 4)
   );cond1
  ((= lacol "BLUE")
    (setq col# 5)
   );cond1
  ((= lacol "MAGENTA")
    (setq col# 6)
   );cond1
  ((= lacol "WHITE")
    (setq col# 7)
   );cond1
  );cond
 (setvar "blipmode" 0)
 (setvar "cmdecho" 0)
 (setvar "osmode" 0)
 (command "graphscr")
 (if (not lacol)(setq lacol "BLUE"))
 (cond
  ((and (not lanam)(= (strlen lacfg) 0))
    (command "layer" "m" "DE$C" "c" "BLUE" "" "")
   );cond1
  ((> (strlen lacfg) 0)
    (command "layer" "m" lacfg "c" lacol "" "")
   );cond1
  ((and lanam
        (/= fla 64)
    );and
    (command "layer" "t" "DE$C" "on" "DE$C" "u" "DE$C" "s" "DE$C" "")
   );cond2
  ((and lanam
        (= fla 64)
    );and
    (command "layer" "on" "DE$C" "u" "DE$C" "s" "DE$C" "")
   );cond3
  );cond ovrall
 (while (not txpt)
         (setq txpt (getpoint "\nPick center of balloon: "))
  );while
 (setq sc (* (getvar "dimscale") 1.25)
       rad 0
       rad1 (* pi 1.5)
       dfht (getvar "textsize")
       txtht (* dfht 1.5)
       baltxt (* dfht 1.0)
       var 0
       txptx (car txpt)
       txpty (cadr txpt)
  );setq
 (while (or (not balstr)(= (strlen balstr) 0)(> (strlen balstr) 24))
  (setq defstr (getvar "users1"))
  (if (or (= shift "All")(= shift "Typed"))
       (setq promp (strcase defstr))
   );if
  (setq promp (strcat "\nEnter Item Number <" defstr ">: ")
        balstr (getstring T promp)
   );setq
  (if (and (= (strlen balstr) 0)(/= (strlen defstr) 0))(setq balstr defstr))
  (if (= (strlen balstr) 0)
       (princ "\nNo null string. Ctrl+C to quit or")
   );if
  (if (and (> (strlen balstr) 0)(< (strlen balstr) 25))
       (setvar "users1" balstr)
   );if
  (if (> (strlen balstr) 24)
       (princ "\nNo tring longer than 24 chrs. Ctrl+C to quit or")
   );if
  );while
 (if (or (= (ascii balstr) 32)(= (ascii balstr) 46))
      (setq hrl (/ dfht 2)
            vrl (/ dfht 2)
       );setq
      (setq bx (textbox (list (cons 1 balstr)))
            hrl (/ (caadr bx) 2)
            vrl (/ (cadadr bx) 2)
       );setq
  );if
  (setq ptmp pxpt
       tcenpt (list txptx (+ txpty (* hrl 4)))
       lcenpt (list txptx (- txpty (* hrl 4)))
       bxl (list (- txptx hrl) txpty)
       bxr (list (+ txptx hrl) txpty)
       p1 (polar bxr (angle lcenpt bxr)(* vrl 1.75))
       p2 (polar bxl (angle lcenpt bxl)(* vrl 1.75))
       p3 (polar bxl (angle tcenpt bxl)(* vrl 1.75))
       p4 (polar bxr (angle tcenpt bxr)(* vrl 1.75))
       angp1 (angle lcenpt bxr)
       angp2 (angle lcenpt bxl)
       angp3 (angle tcenpt bxl)
       angp4 (angle tcenpt bxr)
       ntypa (cons 0 "ARC")
       ntypt (cons 0 "TEXT")
       lanam (cons 8 "DE$C")
       xth (list 210 0.0 0.0 1.0)
  );setq
(entmake (list ntypa
               lanam
               (cons 62 col#)
               (cons 10 lcenpt)
               (cons 40 (distance lcenpt p1))
               (cons 50 angp1)
               (cons 51 angp2)
               xth
          );list
 );entmake
(entmake (list ntypa
               lanam
               (cons 62 col#)
               (cons 10 bxl)
               (cons 40 (distance bxl p2))
               (cons 50 angp2)
               (cons 51 angp3)
               xth
          );list
 );entmake
(entmake (list ntypa
               lanam
               (cons 62 col#)
               (cons 10 tcenpt)
               (cons 40 (distance tcenpt p3))
               (cons 50 angp3)
               (cons 51 angp4)
               xth
          );list
 );entmake
(entmake (list ntypa
               lanam
               (cons 62 col#)
               (cons 10 bxr)
               (cons 40 (distance bxr p4))
               (cons 50 angp4)
               (cons 51 angp1)
               xth
          );list
 );entmake
 (if (or (= shift "All")(= shift "Typed"))
     (setq balstr (strcase balstr))
  );if
(entmake (list ntypt
               lanam
               (cons 62 col#)
               (list 10 0.0 0.0 0.0)
               (cons 40 baltxt)
               (cons 1 balstr)
               txsty
               (cons 72 4)
               (append (list 11) txpt)
               xth
          );list
 );entmake
 (setq pt2 (polar (polar bxr rad (+ dfht (* dfht 0.4))) rad1 (/ txtht 2))
       destxt (getstring t "\nEnter Title: ")
  );setq
 (if (or (= shift "All")(= shift "Typed"))
      (setq destxt (strcase destxt))
  );if
(entmake (list ntypt 
               lanam 
               (cons 62 col#)
               (append (list 10) pt2)
               (cons 40 txtht) 
               (cons 1 destxt) 
               txsty
               (cons 72 0) 
               (list 11 0.0 0.0 0.0) 
               xth 
          );list
 );entmake
 (setq OK T
       destxt nil
       inc (* dfht 1.75)
  );setq 
 (if OK
  (progn (setq promp "\n Enter Cat. No.: "
               fixe "Cat No: "
          );setq
         (prnt)
   );progn
  );if
 (if OK
  (progn (setq promp "\n Enter Description: "
               fixe "Description: "
          );setq
         (prnt)
   );progn
  );if
 (if OK
  (progn (setq promp "\n Enter Qty req'd: "
               fixe "Qty req'd: "
          );setq
         (prnt)
   );progn
  );if
 (if OK
  (progn (if (> (strlen matl) 0)
              (setq promp (strcat "\n Enter Material <"matl"> Type in Yes or your choice: "))
              (setq promp "\n Enter Material: ")
          );if
         (setq fixe "Mat'l: ")
         (prnt)
   );progn
  );if
 (if OK
  (progn (if (> (strlen hard) 0)
              (setq promp (strcat "\n Enter Hardness <"hard"> Type in Yes or your choice: "))
              (setq promp "\n Enter Hardness: ")
          );if
         (setq fixe "Hardness: ")
         (prnt)
   );progn
  );if
 (if OK
  (progn (setq promp "\n Type or Pick Lenght: "
               fixe "Lenght: "
          );setq
         (dstanc)
   );progn
  );if
 (if OK
  (progn (setq promp "\n Type or Pick Diameter: "
               fixe "Diameter: "
          );setq
         (dstanc)
   );progn
  );if
 (if OK
  (progn (setq promp "\n Type or Pick Width: "
               fixe "Width: "
          );setq
         (dstanc)
   );progn
  );if
 (if OK
  (progn (setq promp "\n Type or Pick Thickness: "
               fixe "Thickness: "
          );setq
         (dstanc)
   );progn
  );if
 (if (or OK snot)
  (progn (setq promp "\n Type Special Note: "
               fixe "Note: "
               free T
          );setq
         (prnt)
   );progn
  );if
 (while free
 (setq pt3 (polar pt2 rad1 inc)
       destxt2 (getstring T "\n ENTER< to quit or Type Text: ")
  );setq
 (cond 
  ((= destxt2 "") 
   (setq free nil)
   );cond1
  ((and (> (strlen destxt2) 0)(wcmatch destxt2 "*:*"))
    (progn (setq wstr destxt2
                 pt3 (polar pt2 rad1 inc)
                 str1 ""
            );setq
           (while (wcmatch wstr "*:*")
                   (setq str1 (strcat str1 (substr wstr 1 1))
                         wstr (substr wstr 2)
                         str2 wstr
                    );setq
            );while
           (setq str1 (strcat str1 " "))
           (if (= shift "All")
                (setq str1 (strcase str1))
            );if
           (entmake (list ntypt 
                          lanam 
                          (cons 62 col#)
                          (list 10 0.0 0.0 0.0) 
                          (cons 40 dfht) 
                          (cons 1 str1) 
                          txsty
                          (cons 72 2) 
                          (append (list 11) pt3)
                          xth 
                      );list
            );entmake
           (if (= (substr str2 1 1) " ")(setq str2 (substr str2 2)))
           (if (or (= shift "All")(= shift "Typed"))
                (setq str2 (strcase str2))
            );if
           (entmake (list ntypt 
                          lanam 
                          (cons 62 col#)
                          (append (list 10) pt3)
                          (cons 40 dfht)
                          (cons 1 str2)
                          txsty
                          (cons 72 0)
                          (list 11 0.0 0.0 0.0)
                          xth
                      );list
            );entmake
           (setq pt2 pt3
                 fixed str1
            );setq
     );progn
   );cond2
  ((> (strlen destxt2) 0)
   (progn
     (cond
      (fixed
       (setq pt4 (list (- (car pt3)(caadr (textbox (list (cons 1 fixed)))))(cadr pt3))
             fixed nil
        );setq
       );cond fixed
      (pt4
       (setq pt4 (polar pt4 rad1 inc))
       );cond pt4
      (pt3
       (setq pt4 (polar pt2 rad1 inc))
       );cond pt3
     );cond all 
     (if (or (= shift "All")(= shift "Typed"))
          (setq destxt2 (strcase destxt2))
      );if
     (entmake (list ntypt 
                    lanam 
                    (cons 62 col#)
                    (append (list 10) pt4)
                    (cons 40 dfht) 
                    (cons 1 destxt2) 
                    txsty
                    (cons 72 0) 
                    (list 11 0.0 0.0 0.0) 
                    xth                       
               );list
      );entmake
     (setq pt2 pt3)
    );progn
   );cond4
  );cond overall
  );while free
 (cond
  ((= fla 65)
    (progn (setq kwprp (strcat  "\n When you started DESCription, the layer DE$C was frozen"
                                "\n Do you want to keep it frozen? No or <Yes>: "))
           (initget "Yes No")
           (setq lakw (getkword  kwprp))
           (if (or (= lakw "Yes")(not lakw))
                    (progn (setvar "clayer" cla)
                           (command "layer" "F" "DE$C" "")
                     );progn
            );if
     );progn
   )
  );cond
 (dscreset)
 (princ)
 );defun

(defun prnt()
 (setq prt T)
 (while prt
  (setq promp (strcat "\n ENTER< for next, Blank line, eXit or" promp)
        destr (getstring T  promp)
   );setq
  (cond
   ((= destr "")
     (setq prt nil
      );setq
    );cond1
   ((or (= destr "X")
        (= destr "x")
        (= destr "EXIT")
        (= destr "exit")
        (= destr "Exit")
        (= destr "eXit")
     );or
     (setq prt nil
           OK nil
           free nil
      );setq
    );cond2
   ((or (= destr "B")
        (= destr "b")
        (= destr "BLANK")
        (= destr "blank")
        (= destr "Blank")
     );or
     (setq prt nil
           OK nil
           free T
      );setq
    );cond3
   ((and (= fixe "Hardness: ")
         (or (= destr "Y")
             (= destr "y")
             (= destr "YES")
             (= destr "yes")
             (= destr "Yes")
          );or
     );and
          (progn (setq pt3 (polar pt2 rad1 inc)
                  );setq
                 (if (= shift "All")
                      (setq fixe (strcase fixe))
                  );if
                 (entmake (list ntypt 
                                lanam 
                                (cons 62 col#)
                                (list 10 0.0 0.0 0.0) 
                                (cons 40 dfht) 
                                (cons 1 fixe) 
                                txsty
                                (cons 72 2) 
                                (append (list 11) pt3)
                                xth 
                           );list
                  );entmake
                 (if snot (setq snot nil))
                 (if (or (= shift "All")(= shift "Typed"))
                       (setq destr (strcase hard))
                        (setq destr hard)
                  );if
                 (entmake (list ntypt 
                                lanam 
                                (cons 62 col#)
                                (append (list 10) pt3)
                                (cons 40 dfht) 
                                (cons 1 destr) 
                                txsty
                                (cons 72 0) 
                                (list 11 0.0 0.0 0.0) 
                                xth
                           );list
                  );setq
                 (setvar "users3" destr)
                 (setq pt2 pt3 prt nil fixed fixe)
           );progn
    );cond4
   ((and (= fixe "Mat'l: ")
         (or (= destr "Y")
             (= destr "y")
             (= destr "YES")
             (= destr "yes")
             (= destr "Yes")
          );or
     );and
          (progn (setq pt3 (polar pt2 rad1 inc)
                  );setq
                 (if (= shift "All")
                      (setq fixe (strcase fixe))
                  );if
                 (entmake (list ntypt 
                                lanam 
                                (cons 62 col#)
                                (list 10 0.0 0.0 0.0) 
                                (cons 40 dfht) 
                                (cons 1 fixe) 
                                txsty
                                (cons 72 2) 
                                (append (list 11) pt3)
                                xth
                           );list
                  );entmake
                 (if (or (= shift "All")(= shift "Typed"))
                       (setq destr (strcase matl))
                       (setq destr matl)
                  );if
                 (entmake (list ntypt 
                                lanam 
                                (cons 62 col#)
                                (append (list 10) pt3)
                                (cons 40 dfht) 
                                (cons 1 destr) 
                                txsty
                                (cons 72 0) 
                                (list 11 0.0 0.0 0.0) 
                                xth
                           );list
                  );entmake
                 (setvar "users4" destr)
                 (setq pt2 pt3 prt nil fixed fixe)
           );progn
    );cond5
   ((> (strlen destr) 0)
     (progn (setq pt3 (polar pt2 rad1 inc))
            (if (= shift "All")
                 (setq fixe (strcase fixe))
             );if
            (entmake (list ntypt 
                           lanam 
                           (cons 62 col#)
                           (list 10 0.0 0.0 0.0) 
                           (cons 40 dfht) 
                           (cons 1 fixe) 
                           txsty
                           (cons 72 2) 
                           (append (list 11) pt3)
                           xth
                      );list
             );entmake
            (if (or (= shift "All")(= shift "Typed"))
                 (setq destr (strcase destr))
             );if
            (entmake (list ntypt 
                           lanam 
                           (cons 62 col#)
                           (append (list 10) pt3)
                           (cons 40 dfht) 
                           (cons 1 destr) 
                           txsty
                           (cons 72 0) 
                           (list 11 0.0 0.0 0.0) 
                           xth
                      );list
             );entmake
            (if (or (= fixe "Hardness: ")
                    (= fixe "HARDNESS: ")
                 );or
                     (setvar "users3" destr)
             );if
            (if (or (= fixe "Mat'l: ")
                    (= fixe "MAT'L: ")
                 );or
                     (setvar "users4" destr)
             );if
            (setq pt2 pt3 prt nil fixed fixe)
      );progn
    );cond6
   );cond overall
  );while prt
 (princ)
 );defun prnt

(defun dstanc()
 (setq prt T)
  (while prt
  (setq rawstr nil
        promp (strcat "\n ENTER< for next, Blank line, eXit or" promp)
   );setq
  (initget 134)
  (setq rawstr (getdist promp))
  (cond
   ((not rawstr)
     (setq destr "")
    );cond1
   ((numberp rawstr)
     (if (= fixe "Diameter: ")
          (setq destr (strcat "%%c" (rtos rawstr)))
          (setq destr (rtos rawstr))
      );if
    );cond2
   ((= (type rawstr) 'STR)
     (setq destr rawstr)
    );cond3
   );cond overall
   (cond
   ((= destr "")
     (setq prt nil
      );setq
    );cond1
   ((or (= destr "X")
        (= destr "x")
        (= destr "EXIT")
        (= destr "exit")
        (= destr "Exit")
        (= destr "eXit")
     );or
     (setq prt nil
           OK nil
           free nil
      );setq
    );cond2
   ((or (= destr "B")
        (= destr "b")
        (= destr "BLANK")
        (= destr "blank")
        (= destr "Blank")
     );or
     (setq prt nil
           OK nil
           free T
      );setq
    );cond3
   ((> (strlen destr) 0)
     (progn (setq pt3 (polar pt2 rad1 inc)
             );setq
            (if (= shift "All")
                 (setq fixe (strcase fixe))
             );if
            (entmake (list ntypt 
                           lanam 
                           (cons 62 col#)
                           (list 10 0.0 0.0 0.0) 
                           (cons 40 dfht) 
                           (cons 1 fixe) 
                           txsty
                           (cons 72 2) 
                           (append (list 11) pt3)
                           xth
                      );list
             );entmake
            (if (or (= fixe "Diameter: ")(= fixe "DIAMETER: "))
                 (setq OK nil
                       snot T
                  );setq
             );if
            (if (or (= shift "All")(= shift "Typed"))
                 (setq destr (strcase destr))
             );if
            (entmake (list ntypt 
                             lanam 
                             (cons 62 col#)
                             (append (list 10) pt3)
                             (cons 40 dfht) 
                             (cons 1 destr) 
                             txsty
                             (cons 72 0) 
                             (list 11 0.0 0.0 0.0) 
                             xth
                         );list
             );entmake
            (setq pt2 pt3 prt nil fixed fixe)
      );progn
    );cond4
   );cond overall
   );while prt
 (princ)
 );defun dstanc

(defun descfg ( / caps la lastr lacfg colstr lacol wstr)
 (setq caps (getvar "users2")
       acaderr *error*
       *error* dcfger
  );setq
 (initget "All Typed Shifted")
 (cond
  ((= caps "All")
   (setq caps (getkword "\nUppercase text: Typed, Shifted, <All> ?: ")))
  ((= caps "Typed")
   (setq caps (getkword "\nUppercase text: All, Shifted, <Typed> ?: ")))  
  ((or (= caps "Shifted")(= caps ""))
   (setq caps (getkword "\nUppercase text: All, Typed, <Shifted> ?: ")))
  );cond
 (if caps (setvar "users2" caps))
 (setq lacfg (cdr (assoc 2 (tblsearch "layer" "DE$C")))
       lacol (cdr (assoc 62 (tblsearch "layer" "DE$C")))
       wstr (getvar "users5")
  );setq
 (if (and (not lacfg)(= (strlen wstr) 0))(setq lacfg "DE$C"))
 (if (and (not lacol)(= (strlen wstr) 0))(setq lacol "BLUE"))
 (if (> (strlen wstr) 0)
  (progn
   (setq lacfg "")
   (while (wcmatch wstr "* *")
           (setq lacfg (strcat lacfg (substr wstr 1 1))
                 wstr (substr wstr 2)
                 lacol wstr
            );setq
           (if (wcmatch lacfg "* ")
                (setq lacfg (substr lacfg 1 (1- (strlen lacfg))))
            );if
    );while
   );progn
  );if
 (while (numberp lacol)
  (cond
   ((= lacol 1)
     (setq lacol "RED")
    );cond1
   ((= lacol 2)
     (setq lacol "YELLOW")
    );cond1
   ((= lacol 3)
     (setq lacol "GREEN")
    );cond1
   ((= lacol 4)
     (setq lacol "CYAN")
    );cond1
   ((= lacol 5)
     (setq lacol "BLUE")
    );cond1
   ((= lacol 6)
     (setq lacol "MAGENTA")
    );cond1
   ((= lacol 7)
     (setq lacol "WHITE")
    );cond1
   );cond ovral
  );while
 (setq promp (strcat "\nEnter Layer name for DESCription text <" lacfg ">:")
       lastr (getstring promp))
 (if (> (strlen lastr) 0) (setq lacfg lastr))
 (initget "Red Yellow Green Cyan Blue Magenta White 1 2 3 4 5 6 7")
 (setq promp (strcat "\nEnter Color name for DESCription text <" lacol ">:")
       colstr (getkword promp))
 (if (or (not colstr) (> (strlen colstr) 0))(setq lacol colstr))
 (cond
  ((= lacol "1")
    (setq lacol "RED")
   );cond
  ((= lacol "2")
    (setq lacol "YELLOW")
   );cond
  ((= lacol "3")
    (setq lacol "GREEN")
   );cond
  ((= lacol "4")
    (setq lacol "CYAN")
   );cond
  ((or (= lacol "5")(not lacol))
    (setq lacol "BLUE")
   );cond
  ((= lacol "6")
    (setq lacol "MAGENTA")
   );cond
  ((= lacol "7")
    (setq lacol "WHITE")
   );cond
  );cond ovral
 (setvar "users5" (strcat lacfg " " lacol))
 (setq *error* acaderr)
 (princ)
 );defun

(defun c:desc ()
 (desc))

(defun c:descfg ()
 (descfg))

(princ "\n*****  DESCription.lsp loaded  *****")
(princ "\n* Main: C:Desc ** Config: C:Descfg *")
(princ)
